/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef NPP_DPPLIVEPROCESSCOUNTRELAY_H
#define NPP_DPPLIVEPROCESSCOUNTRELAY_H

#include "controllers/common/acquisition/Count.h"
#include "DPPHistogram.h"
#include "DPPCoincidence.h"

namespace npp {

class DPPLiveProcessCountRelay : public ExperimentController {

public:
	//! Type of controller
	static const std::string TYPE;

	DPPLiveProcessCountRelay(const string& name);
	virtual ~DPPLiveProcessCountRelay();

	virtual void postConfiguration();

	void updateNumor();
	void updateProgression();

private:
	ControllerPtr<acquisition::Count> m_count;
	ControllerPtr<DPPLiveProcess> m_histogramController;
	ControllerPtr<DPPLiveProcess> m_coincidenceController;
};

}

#endif
